
MODULE module_comm_dm

   USE module_comm_dm_0
   USE module_comm_dm_1
   USE module_comm_dm_2
   USE module_comm_dm_3
   USE module_comm_dm_4_

   IMPLICIT NONE

   PRIVATE module_comm_dm_dummy


   INTEGER, PRIVATE :: rsl_sendw_p, rsl_sendbeg_p, rsl_recvw_p, rsl_recvbeg_p
   INTEGER, PRIVATE :: rsl_sendw_m, rsl_sendbeg_m, rsl_recvw_m, rsl_recvbeg_m


   INTEGER, PRIVATE :: idim1, idim2, idim3, idim4, idim5, idim6, idim7


CONTAINS


   SUBROUTINE module_comm_dm_dummy
     USE module_domain, ONLY:domain
     USE module_configure, ONLY:grid_config_rec_type,in_use_for_config
     USE module_state_description, ONLY:PARAM_FIRST_SCALAR
     USE module_driver_constants
     RETURN
   END SUBROUTINE module_comm_dm_dummy
SUBROUTINE SHIFT_HALO_sub ( grid, &
  local_communicator, &
  mytask, ntasks, ntasks_x, ntasks_y, &
  ids, ide, jds, jde, kds, kde, &
  ims, ime, jms, jme, kms, kme, &
  ips, ipe, jps, jpe, kps, kpe )
  USE module_domain, ONLY:domain
  USE module_configure, ONLY:grid_config_rec_type,in_use_for_config
  USE module_state_description, ONLY:PARAM_FIRST_SCALAR
  USE module_driver_constants
  TYPE(domain) , INTENT(IN) :: grid
  INTEGER , INTENT(IN) :: local_communicator
  INTEGER , INTENT(IN) :: mytask, ntasks, ntasks_x, ntasks_y
  INTEGER , INTENT(IN) :: ids, ide, jds, jde, kds, kde
  INTEGER , INTENT(IN) :: ims, ime, jms, jme, kms, kme
  INTEGER , INTENT(IN) :: ips, ipe, jps, jpe, kps, kpe
  INTEGER :: itrace
  INTEGER :: rsl_sendw_p, rsl_sendbeg_p, rsl_recvw_p, rsl_recvbeg_p
  INTEGER :: rsl_sendw_m, rsl_sendbeg_m, rsl_recvw_m, rsl_recvbeg_m
  LOGICAL, EXTERNAL :: rsl_comm_iter
  INTEGER :: idim1, idim2, idim3, idim4, idim5, idim6, idim7
CALL wrf_debug(2,'calling inc/SHIFT_HALO_inline.inc')
IF ( grid%sr_y .GT. 0 ) THEN
CALL rsl_comm_iter_init(grid%parent_grid_ratio,jps,jpe)
DO WHILE ( rsl_comm_iter( grid%id , grid%is_intermediate, grid%parent_grid_ratio , &
                         0 , jds,jde,jps,jpe, grid%njds, grid%njde , &
     rsl_sendbeg_m, rsl_sendw_m, rsl_sendbeg_p, rsl_sendw_p, &
     rsl_recvbeg_m, rsl_recvw_m, rsl_recvbeg_p, rsl_recvw_p ))
 CALL RSL_LITE_INIT_EXCH ( local_communicator, grid%parent_grid_ratio, 0, &
     rsl_sendbeg_m, rsl_sendw_m, rsl_sendbeg_p, rsl_sendw_p, &
     rsl_recvbeg_m, rsl_recvw_m, rsl_recvbeg_p, rsl_recvw_p, &
     0, 0, 4, &
     0, 0, 4, &
     0, 0, 8, &
      0, 0, 4, &
      mytask, ntasks, ntasks_x, ntasks_y, &
(ips-1)*grid%sr_x+1,ipe*grid%sr_x,(jps-1)*grid%sr_y+1,jpe*grid%sr_y,kps,kpe)
   CALL RSL_LITE_EXCH_Y ( local_communicator , mytask, ntasks, ntasks_x, ntasks_y, &
                          rsl_sendw_m, rsl_sendw_p, rsl_recvw_m, rsl_recvw_p )
ENDDO
CALL rsl_comm_iter_init(grid%parent_grid_ratio,ips,ipe)
DO WHILE ( rsl_comm_iter( grid%id , grid%is_intermediate, grid%parent_grid_ratio , &
                         1 , ids,ide,ips,ipe, grid%nids, grid%nide , &
     rsl_sendbeg_m, rsl_sendw_m, rsl_sendbeg_p, rsl_sendw_p, &
     rsl_recvbeg_m, rsl_recvw_m, rsl_recvbeg_p, rsl_recvw_p ))
 CALL RSL_LITE_INIT_EXCH ( local_communicator, grid%parent_grid_ratio, 1, &
     rsl_sendbeg_m, rsl_sendw_m, rsl_sendbeg_p, rsl_sendw_p, &
     rsl_recvbeg_m, rsl_recvw_m, rsl_recvbeg_p, rsl_recvw_p, &
     0, 0, 4, &
     0, 0, 4, &
     0, 0, 8, &
      0, 0, 4, &
      mytask, ntasks, ntasks_x, ntasks_y, &
(ips-1)*grid%sr_x+1,ipe*grid%sr_x,(jps-1)*grid%sr_y+1,jpe*grid%sr_y,kps,kpe)
   CALL RSL_LITE_EXCH_X ( local_communicator , mytask, ntasks, ntasks_x, ntasks_y, &
                          rsl_sendw_m, rsl_sendw_p, rsl_recvw_m, rsl_recvw_p )
    ENDDO
ENDIF
  END SUBROUTINE SHIFT_HALO_sub
END MODULE module_comm_dm
